using System;
using System.Collections.Generic;
//using System.Text;
using System.Windows.Forms;
//using CFFT;

namespace myDirectSoundCapture1
{
    public class CFFT
    {
        //public CFir my_Fir;

        int number_of_sampling;
        int samples_per_second;
        double inv_Sampling_time;//= (double)my_waveformat.SamplesPerSecond / numberOfSpectrum;


        int[] work_area_bit_reversal2;//new int[2 + (int)Math.Sqrt(number_of_sampling)];
        int[] work_area_bit_reversal;//= new int[2 + (int)Math.Sqrt(numberOfSpectrum / 2)];
        double[] sin_cos_table;//= new double[(int)(numberOfSpectrum / 2)];

        double[] w1, w2;

        /*
* ́AcaptureData2@ ֐
* ó@windowed -> FFT-> IFFT ->inv_windowed CaptureData2
*/
        public short[] get_windowed_IFFTed_windowed_FFTed_capture_data(int selected_windowFunc, short[] d)
        {
            double[] result1, result2;
            double[] return_source = new double[d.Length];
            short[] return_result = new short[d.Length];

            result1 = get_windowed_FFTed_capture_data(selected_windowFunc, d);//numberOfSpecturm*2
            result2 = my_ICDFT(result1);//result2=double[numberOfSpectrum]
            Array.Copy(result2, return_source, return_source.Length);

            //t|
            unsafe
            {


                fixed (double* src = &return_source[0])
                {
                    fixed (short* dest = &return_result[0])
                        myFFT.myFFT_Class.inv_WindowFunc(selected_windowFunc, return_result.Length, src, dest);

                }
            }
            return return_result;//short[captureData.length]

        }
        //numberOfSampling*2 FFT result
        public short[] get_windowed_IFFTed_result(int selected_WindowFunc, int capture_data_length, double[] src5)
        {
            short[] return_result = new short[number_of_sampling];
            double[] result1;
            //numberOfSamling      numberOfSampling*2
            result1 = my_ICDFT(src5);
            //t|
            unsafe
            {
                fixed (double* src = &result1[0])
                fixed (short* dest = &return_result[0])
                    myFFT.myFFT_Class.inv_WindowFunc(selected_WindowFunc, return_result.Length, src, dest);

            }
            return return_result;//short[captureData.length]



        }


        //numberOfSampling                  numberOfSampling*2
        public double[] get_half_Power(double[] dummy)
        {

            double[] spectrum_result2 = new double[number_of_sampling / 2];

            for (int i = 0; i < number_of_sampling / 2; i++)
                spectrum_result2[i] = 10 * Math.Log10(inv_Sampling_time * (dummy[2 * i] * dummy[2 * i] +
                                     dummy[2 * i + 1] * dummy[2 * i + 1]));


            return spectrum_result2;
        }


        public CFFT(int samples_per_sec, int samping_number)
        {
            number_of_sampling = samping_number;
            samples_per_second = samples_per_sec;

            work_area_bit_reversal2 = new int[2 + (int)Math.Sqrt(number_of_sampling)];
            sin_cos_table = new double[(int)(number_of_sampling / 2)];

            inv_Sampling_time = samples_per_second / samping_number;

            // my_Fir = new CFir();

        }

        /* myCDFT
         * input=numberOfSpectrum
         * output=numberOfSpectrum*2
         */

        //⏕֐
        public double[] my_CDFT(double[] dummy)  //Complex input FFT
        {

            double[] result4 = new double[number_of_sampling * 2];


            for (int i = 0; i < number_of_sampling; i++)
            {
                result4[2 * i] = dummy[i];
                //result4[2 * i + 1] = dummy[i];    //CaptureData2́A͂sv
            }

            unsafe
            {
                //do FFT    
                fixed (double* a2 = &result4[0])
                {
                    fixed (int* ip2 = &work_area_bit_reversal2[0])
                    {
                        ip2[0] = 0;
                        fixed (double* w = &sin_cos_table[0])
                            myFFT.myFFT_Class.cdft(number_of_sampling * 2, -1, a2, ip2, w);
                    }
                }

            }

            return result4;

        }

        /* my_ICDFT
        * input  = numberOfSampling*2 
        * output = numberOfSampling   
        */
        public double[] my_ICDFT(double[] dummy)
        {

            unsafe
            {
                //do FFT    
                fixed (double* a2 = &dummy[0])
                {
                    fixed (int* ip2 = &work_area_bit_reversal2[0])
                    {
                        ip2[0] = 0;
                        fixed (double* w = &sin_cos_table[0])
                            myFFT.myFFT_Class.cdft(number_of_sampling * 2, 1, a2, ip2, w);
                    }
                }

            }            //tFFT邩Aȉ́AKv
            double[] output_Re = new double[number_of_sampling];
            double[] output_Im = new double[number_of_sampling];

            for (int i = 0; i < number_of_sampling; i++)
            {
                output_Re[i] = dummy[2 * i] * 1.0 / number_of_sampling;
                // output_Im[i] = dummy[2 * i + 1] * 1.0  /number_of_sampling;

                // output_Re[i] = Math.Sqrt(output_Re[i] * output_Re[i] + output_Im[i] * output_Im[i]);
            }


            return output_Re;
        }



        /*  select=selected windowfunction
         * input=short[] source.length
         * output=double  numberOfSpecturm
         *
         */

        public double[] do_window(int select, short[] source)
        {
            double[] destination = new double[number_of_sampling];
            double[] result5 = new double[number_of_sampling];
            //  Array.Copy(source, my_copy, source.Length);
            //|
            unsafe
            {
                fixed (short* src = &source[0])
                fixed (double* dest = &destination[0])
                    myFFT.myFFT_Class.WindowFunc(select, number_of_sampling, src, dest);
            }
            // Array.Copy(destination, result5, destination.Length);
            return destination;//FFTpɁAsampling̏ĂB= numberOfSampling

        }
        /*  select=selected windowfunction
         * input=double[] source.length
         * output=double  source.length
         *
         */

        /*   public double[] do_window(int select, double[] source )
           {
             double[] destination = new double[source.Length];
               double[] returning = new double[number_of_sampling];
               //|
               unsafe
               {


                   fixed (double* src = &source[0])
                   {
                       fixed (double* dest = &destination[0])
                           myFFT_Class.WindowFunc(select, returning.Length, src, dest);//source.lengthH

                   }
               }
               Array.Copy(destination, returning, destination.Length);
               return returning;
           
           }*/
        private void make_w1_w2(int win_frame_size)
        {
            w1 = new double[win_frame_size];
            w2 = new double[win_frame_size];

            for (int i = 0; i < win_frame_size; i++)
            {
                w1[i] = (1 + Math.Cos(i * Math.PI / (win_frame_size - 1))) / 2;
                w2[i] = (1 + Math.Cos((-(win_frame_size - 1) + i) * Math.PI / (win_frame_size - 1))) / 2;
                // w2[i] = 1.0 - w1[i] ;
            }


        }
        /*
         * return=former.length
         * */
        public short[] get_newCaptureData_for_short_time_FFT(short[] former, short[] current)
        {
            short[] mixed = new short[former.Length];

            if (former.Length != current.Length)
                return mixed;

            Array.Copy(former, mixed.Length, mixed, 0, mixed.Length);//Ocapture㔼mixed̑O
            Array.Copy(current, 0, mixed, mixed.Length, mixed.Length);//capturȇOmixeď㔼

            return mixed;
        }
        /*
         * return = double[numberOfSpectrum*2]
         * */
        public double[] get_windowed_FFTed_capture_data(int sel, short[] s)
        {
            double[] base1, returning;
            //܂A|
            base1 = do_window(sel, s);//return = double[]

            double[] base_for_FFT = new double[number_of_sampling];

            Array.Copy(base1, base_for_FFT, base1.Length);//Œݍ݂̏\
            returning = my_CDFT(base_for_FFT);
            return returning;//double[numberOfSpectrum*2]

        }







    }
}
