using System;
using System.Drawing;
using System.Windows.Forms;
using System.IO;

using System.Threading;     //Thread
using Microsoft.DirectX;
using Microsoft.DirectX.DirectSound;
using Microsoft.DirectX.Direct3D;

using System.Diagnostics;   //Process
using myFFT;

namespace myDirectSoundCapture1
{

    public partial class MainForm : Form
    {
        //Direct3D device
        private Microsoft.DirectX.Direct3D.Device device;
        private VertexBuffer vBuffer, vBuffer2, vBuffer3, vBuffer4, vBuffer_peak, vBuffer_mouse;
        //for spectrum
        private CustomVertex.TransformedColored[] custumVertcies_spect;
        private CustomVertex.TransformedColored[] custumVertcies_peek;
        private CustomVertex.TransformedColored[] custumVertcies_mouse = new CustomVertex.TransformedColored[10];

        //for Oscillo
        private CustomVertex.TransformedColored[] custumVertcies_oscillo;
        private CustomVertex.TransformedColored[] grid1 = new CustomVertex.TransformedColored[50];
        //for spectrum 
        private CustomVertex.TransformedColored[] grid2 = new CustomVertex.TransformedColored[60];

        private Microsoft.DirectX.Direct3D.Font directX_Font;
        private Microsoft.DirectX.Direct3D.Font directX_Font_big;

        //DirectX3Dp̃tHǵׂAVXetHg
        private System.Drawing.Font my_Font = new System.Drawing.Font("Arial", 8);
        private System.Drawing.Font my_Font_big = new System.Drawing.Font("Arial", 10, FontStyle.Bold);

        private double[] hosei = new double[6] { 0.6, 5.6, 5.1, 7.0, 8.2, 4.0 };//遁@グ遁
       // private double[] NumberOfSpect_hosei = new double[6] { 0.0, 3, 6, 9, 12, 15 };//t




        //Capture Device֌W
        private Guid CaptureDeviceGuid = Guid.Empty;
        CaptureDevicesCollection devices = new CaptureDevicesCollection();

        private Capture capture = null;
        private WaveFormat my_waveformat;

        //Buffer֌W
        private CaptureBuffer captureBuffer = null;
        private CaptureBufferDescription captureDesc;

        //Notify֌W
        private int NotifySize = 8192;
        private const int NumberRecordNotifications = 5;   //ƁA悸A߂ 10 = 88820 points
        private Thread NotifyThread = null;

        private AutoResetEvent NotificationEvent = new AutoResetEvent(false);
        private Notify applicationNotify = null;
        BufferPositionNotify[] PositionNotify = new BufferPositionNotify[NumberRecordNotifications];
        //int SampleCount = 0;
        private int NotifyPos = 0;
        //fileƁARecording֌W

        //read ini.file 
        private StreamReader sr;
        private bool alredyRead = false;
        private bool Recording = true;

        //       private FileStream WaveStream = null;
        //       private BinaryWriter Writer = null;

        //IVp
        bool hakei_seishi = false;
        int mag = 1;

        short[] CaptureData2 = null;
        short[] captureData_copy = null;
        int recStartPos;
        Array ary, array_peak;
        int vertical = 60;


        Pen penGreen = new Pen(Color.Green);
        Pen penRed = new Pen(Color.Red);
        Pen penIvory = new Pen(Color.Ivory);
        Pen penChatreuse = new Pen(Color.Chartreuse);

        //for Spectrum
        static int numberOfSpectrum = 32768;

        double maxPower = 400;
        // Fft fft;
        // Hamming ham = null;
        double[] result;
        double MaxHz = 0;
        int max_index = 0;

        double[] spectrum_result;
        double inv_Sampling_time;
        double[] peakHold = new double[512];
        bool isPeakhold = false;
        double MaxValue = 0f;

        //Normalize
        bool toPeak = false;
        bool norm = false;
        double[] Ynormalize_factor;

        double adjust = 0f;

        bool inspector = false;
        bool Notified = false;

        //process
        //Process[] myProcesses;

        //for FPS measurement
        int before, now, frame_max;
        //const int FPS = 60;
        int frame = 0;

        //window func
        int selected = 1;
        //vʗp
        double Vrms = 0;
        double Vp_p = 0;
        double Vp_o = 0;
        bool correct = false;
        float oscill_max = 0;

        double moused_Hz = 0;
        double moused_dB = 0;


        public MainForm()
        {
            InitializeComponent();

            CaptureDeviceGuid = devices[0].DriverGuid;

            try
            {
                capture = new Capture(CaptureDeviceGuid);
            }
            catch { }

            my_waveformat.SamplesPerSecond = 48000;
            my_waveformat.BitsPerSample = 16;
            my_waveformat.Channels = 1;
            my_waveformat.FormatTag = WaveFormatTag.Pcm;

            my_waveformat.BlockAlign = (short)((my_waveformat.Channels) * (my_waveformat.BitsPerSample / 8));
            my_waveformat.AverageBytesPerSecond = my_waveformat.BlockAlign * my_waveformat.SamplesPerSecond;

            inv_Sampling_time = (double)my_waveformat.SamplesPerSecond / numberOfSpectrum;

            //---------------------------------------------------------------------------------------------------            
            //Direct3D
            PresentParameters pp = new PresentParameters();
            pp.Windowed = true;
            pp.SwapEffect = SwapEffect.Discard;
            pp.DeviceWindow = pictureBox2;
            try
            {
                device = new Microsoft.DirectX.Direct3D.Device(0, DeviceType.Hardware, null,
                    CreateFlags.SoftwareVertexProcessing, pp);
            }
            catch
            {

            }
            //DirectX Font

            directX_Font = new Microsoft.DirectX.Direct3D.Font(device, my_Font);
            directX_Font_big = new Microsoft.DirectX.Direct3D.Font(device, my_Font_big);

            //----------------------------------

        }

        CFFT my_FFT;

        private void recButton_Click(object sender, EventArgs e)
        {
            Recording = !Recording; //Recording=true ŁACapture
            hakei_seishi = true;
            appli_state_save();
            if (captureBuffer != null) captureBuffer.Dispose();
            captureBuffer = null;
            if (NotifyThread != null) NotifyThread.Abort();
            NotifyThread = null;
            //----------------------------------------------------------------
            //Direc3D
            device.Dispose();
            device = null;

            vBuffer.Dispose();
            vBuffer = null;
            Close();


        }

        void CreateCaptureBuffer() //ŁACreate邩H
        {
            if (captureBuffer != null)
            {
                captureBuffer.Dispose();
                captureBuffer = null;
            }
            captureDesc = new CaptureBufferDescription();

            //CaptureBuffeŕABufferBytes߂ȂƁAłȂBNotifySize߂āAɌ߂
            NotifySize = numberOfSpectrum * 2;//1f[^2byte₩


            //NotifySizéABlockAlign̐{łȂƁA܂B
            NotifySize -= NotifySize % my_waveformat.BlockAlign;

            //CaptureData2 = new short[(numberOfSpectrum >= NotifySize) ? numberOfSpectrum :NotifySize  ];
            CaptureData2 = new short[NotifySize];

            //ŁANotifySize܂ABufferSizéANumberRecordNotifications{
            captureDesc.BufferBytes = NotifySize * NumberRecordNotifications;

            captureDesc.Format = my_waveformat;

            try
            {
                captureBuffer = new CaptureBuffer(captureDesc, capture);
            }
            catch
            {
                return;
            }

            //-----------------------------------------------------------------------------------------            
            //Direct3D
            custumVertcies_spect = new CustomVertex.TransformedColored[512];
            custumVertcies_peek = new CustomVertex.TransformedColored[512];

            custumVertcies_oscillo = new CustomVertex.TransformedColored[512];
            InitNotifications();
        }

        void InitNotifications()
        {
            if (null == captureBuffer)
                throw new NullReferenceException();

            //Notifications҂AXbh쐬B

            NotifyThread = new Thread(new ThreadStart(WaitThread));
            NotifyThread.Start();

            //ʒmݒ肷ɂ́ÃXebvsB
            //1.ꂼ̒ʒmʒuɑ΂ AutoResetEvent 쐬B
            //NotificationEvent=new AutoResetEvent(false);

            //2.Notify RXgN^ CaptureBuffer IuWFNgnāANotify IuWFNg擾B
            applicationNotify = new Notify(captureBuffer);

            //3.ꂼ̒ʒmʒu 1 ABufferPositionNotify \̂̔z쐬B
            //   Offset oɁAʒm𔭐ꏊ̃oCg ItZbgݒ肷B

            //4.EventNotifyHandle oɁAXebv 1 ō쐬ꂩ̃Cxg
            //  AutoResetEvent.Handle ݒ肷B
            for (int i = 0; i < NumberRecordNotifications; i++)
            {
                // PositionNotify[i].Offset = NotifySize * (i + 1) - 1;   //-1ȂāA悢̂H ȂƁASetNotificationPosition()łȂ.....
                PositionNotify[i].Offset = NotifySize * (i + 1) - 1;   //-1ȂāA悢̂H ȂƁASetNotificationPosition()łȂ.....

                PositionNotify[i].EventNotifyHandle = NotificationEvent.SafeWaitHandle.DangerousGetHandle();
            }

            //5.Notify.SetNotificationPositions ĂяoāABufferPositionNotify \̂̔znB
            applicationNotify.SetNotificationPositions(PositionNotify, NumberRecordNotifications);

        }


        private void WaitThread()
        {

            while (Recording)
            {
                NotificationEvent.WaitOne(Timeout.Infinite, true);
                // Thread.Sleep(400);
                recStartPos = NotifySize * NotifyPos;
                if (all_done)
                    Invalidate();

                NotifyPos++;
                NotifyPos %= NumberRecordNotifications; //Buffer͏z邩B

            }
        }
            private void Capture_Data()
            {

                CaptureData2 = (short[])(captureBuffer.Read(recStartPos, typeof(short),
                    Microsoft.DirectX.DirectSound.LockFlag.None, NotifySize));

                Notified = true;

            }


        private void toPeak_calculate()
        {

            for (int i = 0; i < 512; i++)
            {
                //peak␳
                custumVertcies_spect[i].Y -= (float)(maxPower - 161);

                //̑ш搧          
                custumVertcies_spect[i].Y = (float)((280 + 120 >= custumVertcies_spect[i].Y)
                    ? custumVertcies_spect[i].Y : 280 + 120);

                if (custumVertcies_spect[i].Y <= 40) custumVertcies_spect[i].Y = 40;

                ary.SetValue(custumVertcies_spect[i], i);


            }
        }
        int freq_mag = 1;
        int magnifier = 2;//NumberOfSpecturm=2048
        int start_point = 0;

        private void draw_spect(int start, int delta_current)
        {

            int k = 0;
           // if(!show_input)
                spectrum_result = my_FFT.get_half_Power(FFTed_result);

            if (freq_mag != 1)
            {
                if (start <= 0 && delta_current <= 0) delta_current = 0;
                k = start + delta_current;

            }

            if (k < 0) k = 0;
            start_point = k;
            if (k == 0) start_pos = delta = delta_current = 0;

            MaxValue = 0;
            double currentY;
            magnifier = numberOfSpectrum / 1024;
            double division_Max = 0f;

            ary = vBuffer.Lock(0, LockFlags.None);
            maxPower = 400;

            int m = (int)(magnifier / freq_mag);//   magnifier = numberOfSpectrum / 1024

            array_peak = vBuffer_peak.Lock(0, LockFlags.None);

            //ϒlƂ͎̂sAőlƂ
            for (int i = 0; i < 512; i++)
            {
                division_Max = 0f;
                for (int j = 0; j < m; j++)
                {
                    if (j + k < numberOfSpectrum / 2)
                    {
                        division_Max = Math.Max(division_Max, spectrum_result[j + k]);

                        //őp[̈ʒuAlvZp
                        if (MaxValue <= spectrum_result[j + k])
                        {
                            MaxValue = spectrum_result[j + k];
                            max_index = j + k;
                        }
                    }
                }
                //ۂŸʒuvZ

                currentY = (float)(511.5 - adjust - 2 * division_Max -
                    hosei[WindowFunc_comboBox.SelectedIndex] );

                //̒ŁAō̃p[(Wł́Aŏ_j
                if (maxPower >= currentY)
                {
                    maxPower = currentY;
                }

                //for normalize
                if (norm) currentY -= Ynormalize_factor[i];
                switch (freq_mag)
                {
                    case 2: custumVertcies_spect[i].Color = Color.Pink.ToArgb(); break;
                    case 4: custumVertcies_spect[i].Color = Color.Aquamarine.ToArgb(); break;
                    case 8: custumVertcies_spect[i].Color = Color.YellowGreen.ToArgb(); break;
                    case 16: custumVertcies_spect[i].Color = Color.Pink.ToArgb(); break;
                    case 32: custumVertcies_spect[i].Color = Color.Aqua.ToArgb(); break;
                    case 64: custumVertcies_spect[i].Color = Color.YellowGreen.ToArgb(); break;
                    default: custumVertcies_spect[i].Color = Color.White.ToArgb();
                        break;
                }

                //ۂYA͂ݏoȂ悤ɁAш搧
                if (!toPeak)
                {
                    //custumVertcies_spect[i].Y = (float)(-40 - currentY);
                    custumVertcies_spect[i].Y = (float)((400 >= currentY) ? currentY : 400);
                    //if (custumVertcies_spect[i].Y <= 40) custumVertcies_spect[i].Y = 40;
                }
                else
                    custumVertcies_spect[i].Y = (float)currentY;

                if (isPeakhold)
                {
                    custumVertcies_peek[i].Y = Math.Min(custumVertcies_peek[i].Y,
                                                        custumVertcies_spect[i].Y);

                    array_peak.SetValue(custumVertcies_peek[i], i);
                }

                ary.SetValue(custumVertcies_spect[i], i);


                k += (int)(magnifier / freq_mag);//   magnifier = numberOfSpectrum / 2048


            }
            if (toPeak) toPeak_calculate();

            vBuffer.Unlock();
            vBuffer_peak.Unlock();

            if (max_index > 1)
            {
                MaxHz = (max_index) * my_waveformat.SamplesPerSecond / numberOfSpectrum;
            }
            //␳ 100mV -20.0dB
            MaxValue -= 176.14 ;
            //グ遁@=
            //vʂVrms,Vp_pZo
            Vrms = Math.Pow(10.0f, (MaxValue + hosei[WindowFunc_comboBox.SelectedIndex] + adjust / 2) / 20);
            Vrms = (double)1000.0 * Vrms;  //mVɊZ
            Vp_p = 2 * Math.Sqrt(2) * Vrms;
            Vp_o = Math.Sqrt(2) * Vrms;

        }


        double correct_dB = 0;
        double[] FFTed_result;

        bool all_done = true;
        protected override void OnPaint(PaintEventArgs e)
        {

            base.OnPaint(e);
            //---------------------------------------------------------------------------------------------
            // CaptureData2.Initialize();
            Capture_Data();
           // CaptureData2 = (short[])(captureBuffer.Read(recStartPos, typeof(short),
             //           Microsoft.DirectX.DirectSound.LockFlag.None, NotifySize));

            all_done = false;

            //B␳pf[^@2KH@100mVrms@-20dB 15400
            if (correct) for (int i = 0; i < numberOfSpectrum; i++)
                    CaptureData2[i] = (short)(15400 * Math.Sin(2 * Math.PI
                        * 2000 * numberOfSpectrum / my_waveformat.SamplesPerSecond * i / (numberOfSpectrum - 1)));
            if (hakei_seishi)
                CaptureData2 = captureData_copy;

            // Notified = true;
            captureData_copy = CaptureData2;

            //if (Notified)
            {
                inspector = !inspector;//ԂƗ΂̓_ł̎

                FFTed_result = my_FFT.get_windowed_FFTed_capture_data(selected, CaptureData2);

                draw_oscillo_grid();
                draw_spect_grid();
                draw_spect(start_pos, delta);

                draw_oscillo_wave();



                //DirectX draw
                device.Clear(ClearFlags.Target, Color.Black, 0, 0);

                device.BeginScene();

                device.SetStreamSource(0, vBuffer2, 0);
                device.VertexFormat = CustomVertex.TransformedColored.Format;
                device.DrawPrimitives(PrimitiveType.LineList, 0, 28);
                if (!hide_origin) //g`Î~́A\Ȃ
                {
                    device.SetStreamSource(0, vBuffer, 0);
                    device.VertexFormat = CustomVertex.TransformedColored.Format;
                    device.DrawPrimitives(PrimitiveType.LineStrip, 0, 511);
                }
                device.SetStreamSource(0, vBuffer3, 0);
                device.VertexFormat = CustomVertex.TransformedColored.Format;
                device.DrawPrimitives(PrimitiveType.LineList, 0, 28);

                device.SetStreamSource(0, vBuffer4, 0);
                device.VertexFormat = CustomVertex.TransformedColored.Format;
                device.DrawPrimitives(PrimitiveType.LineStrip, 0, 511);

                if (isPeakhold)
                {
                    device.SetStreamSource(0, vBuffer_peak, 0);
                    device.VertexFormat = CustomVertex.TransformedColored.Format;
                    device.DrawPrimitives(PrimitiveType.LineStrip, 0, 511);
                }
                if (oscill_max >= 32767)
                    directX_Font_big.DrawText(null, "Level over", 280, 4, Color.Red);


                //drawFont
                directX_Font_big.DrawText(null, "dB", 14, 10 + 120, Color.Wheat);

                //cڐ
                directX_Font.DrawText(null, "0", 28, 34 + 120, Color.White);
                for (int i = -1; i > -13; i--)
                {
                    if (i > -10)
                        directX_Font.DrawText(null, (i * 10).ToString(), 20, (35 - i * 20 + 120), Color.White);
                    else
                        directX_Font.DrawText(null, (i * 10).ToString(), 15, (35 - i * 20 + 120), Color.White);
                }

                //gڐ
                for (int i = 0; i < 13; i++)
                    directX_Font.DrawText(null, (((i * my_waveformat.SamplesPerSecond / 24000.0) / (double)freq_mag) + start_point * my_waveformat.SamplesPerSecond / numberOfSpectrum / 1000.0).ToString("N2"),
                        32 + i * 512 / 12, 290 + 120, Color.White);


                directX_Font_big.DrawText(null, "KHz", 574, 290 + 120, Color.Wheat);

                if (!hakei_seishi)
                {
                    if (inspector)
                        directX_Font_big.DrawText(null, "o", 16, 16, Color.Chartreuse);
                    else
                        directX_Font_big.DrawText(null, "o", 16, 16, Color.Red);
                }

                if (isLeftMouse_Clicked)
                {
                    double mouse_pos_Vrms = 0;
                    moused_Hz = pos * (magnifier / freq_mag) * my_waveformat.SamplesPerSecond / numberOfSpectrum
                                + start_point * my_waveformat.SamplesPerSecond / numberOfSpectrum;
                    moused_dB = (159.2 - custumVertcies_spect[pos].Y) / 2.0;
                    if (!toPeak)
                        correct_dB = moused_dB;
                    directX_Font_big.DrawText(null, "= Diff ="
                        , 562, 230, Color.Yellow);
                    if (!toPeak)
                    {
                        directX_Font_big.DrawText(null, (moused_dB - (MaxValue + hosei[WindowFunc_comboBox.SelectedIndex] + adjust / 2)).ToString("N1") + " dB"
                        , 578, 250, Color.Yellow);
                    }
                    else    //toPeakɎčs
                        directX_Font_big.DrawText(null, moused_dB.ToString("N1") + " dB"
                            , 578, 250, Color.Yellow);
                    directX_Font_big.DrawText(null, (moused_Hz - MaxHz).ToString("N0") + " Hz"
                         , 576, 270, Color.Yellow);

                    //vʂVrms,Vp_pZo

                    mouse_pos_Vrms = Math.Pow(10.0f, (correct_dB) / 20);
                    mouse_pos_Vrms *= 1000.0f;//mVɊZ
                    if (!toPeak)
                    {
                        if (mouse_pos_Vrms > 1)
                        {
                            directX_Font_big.DrawText(null, mouse_pos_Vrms.ToString("N0") + " mV rms"
                            , 576, 300, Color.White);
                        }
                        else
                        {
                            mouse_pos_Vrms *= 1000.0f;  //uVɊZ
                            directX_Font_big.DrawText(null, mouse_pos_Vrms.ToString("N0") + " V rms"
                            , 576, 300, Color.White);
                        }
                    }
                    directX_Font_big.DrawText(null, moused_Hz.ToString("N0") + " Hz"
                                , 576, 320, Color.White);
                    device.SetStreamSource(0, vBuffer_mouse, 0);
                    device.VertexFormat = CustomVertex.TransformedColored.Format;
                    device.DrawPrimitives(PrimitiveType.LineList, 0, 1);

                }

                if (Vrms < 1)
                {
                    Vrms *= 1000.0f;  //uVɊZ
                    Vp_o = Math.Sqrt(2) * Vrms;

                    directX_Font_big.DrawText(null, Vrms.ToString("N0") + " V rms"
                    , 576, 60, Color.White);
                    directX_Font_big.DrawText(null, Vp_o.ToString("N0") + " V p_o",
                                            576, 80, Color.White);

                }
                else
                {

                    directX_Font_big.DrawText(null, Vrms.ToString("N0") + " mV rms",
                        570, 60, Color.White);
                    directX_Font_big.DrawText(null, Vp_o.ToString("N0") + " mV p_o",
                                            570, 80, Color.White);
                }

                directX_Font_big.DrawText(null, "= Max Pos ="
                    , 562, 165, Color.White);

                directX_Font_big.DrawText(null, MaxHz.ToString("N0") + " Hz",
                    576, 185, Color.White);

                directX_Font_big.DrawText(null, (MaxValue + hosei[WindowFunc_comboBox.SelectedIndex]
                    + adjust / 2).ToString("N1") + " dB",
                    578, 205, Color.White);
                /* if(start_point==0 && freq_mag!=1 )
                     directX_Font_big.DrawText(null, " border",
                       40, 160, Color.Yellow);   */


                device.EndScene();
                device.Present();

                if (!hakei_seishi)
                    maxPower = 400;

                //FPS
                frame++;
                now = Environment.TickCount;
                if ((now - before) >= 1000)
                {
                    // frame_max = Math.Max(frame_max, frame);
                    frame_max = frame;
                    FPS_label.Text = frame_max + " frame/sec";
                    before = now;
                    frame = 0;
                }

            }
            // Notified = false;
            all_done = true;

        }
        private void prepare_draw_oscillo_wave()
        {
            ary = vBuffer4.Lock(0, LockFlags.None);

            for (int i = 0; i < 512; i++)
            {
                custumVertcies_oscillo[i].Z = 0;
                custumVertcies_oscillo[i].Rhw = 1.0f;

                ary.SetValue(custumVertcies_oscillo[i], i);

            }
            vBuffer4.Unlock();

        }
        private void prepare_draw_spect()
        {
            ary = vBuffer.Lock(0, LockFlags.None);
            for (int i = 0; i < 512; i++)
            {

                custumVertcies_spect[i].X = i + 40;
                custumVertcies_spect[i].Z = 0;
                custumVertcies_spect[i].Rhw = 1.0f;
                custumVertcies_spect[i].Color = Color.Ivory.ToArgb();

                ary.SetValue(custumVertcies_spect[i], i);
            }
            vBuffer.Unlock();

            array_peak = vBuffer_peak.Lock(0, LockFlags.None);
            for (int i = 0; i < 512; i++)
            {
                custumVertcies_peek[i].Y = 400;
                custumVertcies_peek[i].X = i + 40;
                custumVertcies_peek[i].Z = 0;
                custumVertcies_peek[i].Rhw = 1.0f;
                custumVertcies_peek[i].Color = Color.Chartreuse.ToArgb();
                array_peak.SetValue(custumVertcies_peek[i], i);
            }
            vBuffer_peak.Unlock();

        }


        private void draw_spect_grid()
        {
            ary = vBuffer2.Lock(0, LockFlags.None);

            //
            for (int i = 0; i < 26; i += 2)
            {
                grid2[i].X = 40;
                grid2[i].Y = grid2[i + 1].Y = 40 + i * 200 / 20 + 120;
                grid2[i + 1].X = 512 + 40;


                grid2[i].Z = grid2[i + 1].Z = 0;
                grid2[i].Rhw = grid2[i + 1].Rhw = 1.0f;
                if (i == 12)
                    grid2[i].Color = grid2[i + 1].Color = Color.DarkRed.ToArgb();
                else
                    grid2[i].Color = grid2[i + 1].Color = Color.Green.ToArgb();
                if (i == 0 | i == 24)
                    grid2[i].Color = grid2[i + 1].Color = Color.LimeGreen.ToArgb();

                ary.SetValue(grid2[i], i);
                ary.SetValue(grid2[i + 1], i + 1);
            }

            //c
            for (int i = 26; i < 52; i += 2)
            {
                grid2[i].X = grid2[i + 1].X = 40.0f + (512.0f / 12.0f * (float)((i - 26) / 2));
                grid2[i].Y = 40 + 120;
                grid2[i + 1].Y = 240 + 40 + 120;
                grid2[i].Z = grid2[i + 1].Z = 0;
                grid2[i].Rhw = grid2[i + 1].Rhw = 1.0f;
                grid2[i].Color = grid2[i + 1].Color = Color.Green.ToArgb();
                if (i == 26 | i == 50)
                    grid2[i].Color = grid2[i + 1].Color = Color.LimeGreen.ToArgb();
                if (i == 38)
                    grid2[i].Color = grid2[i + 1].Color = Color.DarkRed.ToArgb();
                ary.SetValue(grid2[i], i);
                ary.SetValue(grid2[i + 1], i + 1);

            }

            vBuffer2.Unlock();

        }

        private void draw_oscillo_grid()
        {

            //r\

            //
            ary = vBuffer3.Lock(0, LockFlags.None);

            for (int i = 0; i < 22; i += 2)
            {

                grid1[i].X = 40;
                grid1[i].Y = grid1[i + 1].Y = 20 + i * 120 / 20;
                grid1[i + 1].X = 512 + 40;
                grid1[i].Z = grid1[i + 1].Z = 0;
                grid1[i].Rhw = grid1[i + 1].Rhw = 1.0f;

                if (i == 10)
                    grid1[i].Color = grid1[i + 1].Color = Color.DarkRed.ToArgb();
                else
                    grid1[i].Color = grid1[i + 1].Color = Color.Green.ToArgb();

                ary.SetValue(grid1[i], i);
                ary.SetValue(grid1[i + 1], i + 1);
            }

            //c
            for (int i = 22; i < 48; i += 2)
            {
                grid1[i].X = grid1[i + 1].X = 40.0f + (512.0f / 12.0f * (float)((i - 22) / 2));

                grid1[i].Y = 20;
                grid1[i + 1].Y = 120 + 20;
                grid1[i].Z = grid1[i + 1].Z = 0;
                if (i == 34)
                    grid1[i].Color = grid1[i + 1].Color = Color.DarkRed.ToArgb();
                else
                    grid1[i].Color = grid1[i + 1].Color = Color.Green.ToArgb();

                grid1[i].Rhw = grid1[i + 1].Rhw = 1.0f;
                ary.SetValue(grid1[i], i);
                ary.SetValue(grid1[i + 1], i + 1);

            }


            vBuffer3.Unlock();
        }


        private void draw_oscillo_wave()
        {

            short[] new_capture_data;
            if (show_input)
                new_capture_data = CaptureData2;
            else
                new_capture_data = my_FFT.get_windowed_IFFTed_result(selected, CaptureData2.Length, FFTed_result);

            oscill_max = 0;
            int trig2 = 0;
            for (int j = 0; j < 100; j++)
                // if (CaptureData2[j] > 0 && CaptureData2[j + 1] < 0)
                if (new_capture_data[j] > 0 && new_capture_data[j + 1] < 0)
                {
                    trig2 = j;
                    break;
                }
            short[] temp_array = new short[new_capture_data.Length - trig2];

            Array.Copy(new_capture_data, trig2, temp_array, 0, new_capture_data.Length - trig2);

            //  if (Notified)
            {
                ary = vBuffer4.Lock(0, LockFlags.None);
                float temp;
                for (int i = 0; i < 512; i++)
                {
                    if (oscill_max <= temp_array[i])
                        oscill_max = temp_array[i];

                    temp = 80 + temp_array[i] * vertical / 32767;

                    temp = custumVertcies_oscillo[i].Y = temp < 20 ? 20 : temp;

                    custumVertcies_oscillo[i].Y = temp > 140 ? 140 : temp;


                    if (i * mag + 40 < 552)
                    {
                        custumVertcies_oscillo[i].X = i * mag + 40;
                        custumVertcies_oscillo[i].Color = Color.Gold.ToArgb();
                    }
                    // X=552Ŕg`؂Ă܂
                    else
                    {
                        custumVertcies_oscillo[i].X = 552;
                        custumVertcies_oscillo[i].Color = Color.Green.ToArgb();
                    }

                    ary.SetValue(custumVertcies_oscillo[i], i);

                }

                vBuffer4.Unlock();

            }

        }





        private void FFT_normalize(int m)
        {

            double[] normalize = new double[512];

            for (int p = 0; p < m; p++)
            {
                // do FFT
                //myFFT();
                int k = 0;
                double currentY;
                int magnifier = numberOfSpectrum / 2048;
                double division_Max = 0f;

                maxPower = 400;
                int s = (int)(2 * magnifier / freq_mag);//   magnifier = numberOfSpectrum / 2048

                //ϒlƂ ͑ʖځBőlƂ
                for (int i = 0; i < 512; i++)
                {
                    division_Max = 0f;
                    Ynormalize_factor[i] = 1000;
                    for (int j = 0; j < s; j++)
                        division_Max = Math.Max(division_Max, spectrum_result[j + k]);

                    currentY = (float)(511.5 - adjust - 2 * division_Max -
                        hosei[WindowFunc_comboBox.SelectedIndex] );

                    //for normalize

                    if (currentY > 380)//{400ł邪A炢̂380
                        currentY = 400;

                    Ynormalize_factor[i] = Math.Min(Ynormalize_factor[i], currentY - 400);//Ot̉̋
                    normalize[i] += Ynormalize_factor[i];
                    k += (int)(2 * magnifier / freq_mag);//   magnifier = numberOfSpectrum / 2048
                    //  currentY = 378.64 - Ynormalized - adjust - 2 * division_Max;

                }

            }
            for (int i = 0; i < 512; i++)
                Ynormalize_factor[i] = normalize[i] / m;

            normalize = null;

        }


        //----------------------------------------------------------------------------------------------------------

        private void stop_button_Click(object sender, EventArgs e)
        {
            maxPower = 400;

            hakei_seishi = !hakei_seishi;
            if (hakei_seishi)
            {
                stop_button.Text = "g`ϑ Resume";
                stop_button.BackColor = Color.Tomato;
            }
            else
            {
                stop_button.Text = "g`Î~ Pause";
                stop_button.BackColor = Color.Chartreuse;
            }

        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            mag = 1;
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            mag = 2;
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            mag = 4;
        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            mag = 6;
        }

        private void radioButton5_CheckedChanged(object sender, EventArgs e)
        {
            mag = 8;
        }

        private void radioButton6_CheckedChanged(object sender, EventArgs e)
        {
            mag = 10;
        }

        private void peak_button_Click(object sender, EventArgs e)
        {
            isPeakhold = !isPeakhold;
            if (isPeakhold)
            {
                peak_button.BackColor = Color.Red;
            }
            else
            {
                array_peak = vBuffer_peak.Lock(0, LockFlags.None);
                for (int i = 0; i < 512; i++)
                    custumVertcies_peek[i].Y = 400;


                vBuffer_peak.Unlock();

                peak_button.BackColor = Color.Chartreuse;
                toPeak_button.Visible = true;

            }

        }

        private void norm_button_Click_1(object sender, EventArgs e)
        {
            norm = !norm;
            if (norm)
            {
                FFT_normalize(100);
                norm_button.BackColor = Color.Tomato;

            }
            else
            {
                norm_button.BackColor = Color.Chartreuse;
            }

        }

        private void adjust_UpDown_ValueChanged(object sender, EventArgs e)
        {
            adjust = (double)adjust_UpDown.Value * 2.0;
        }

        private void vertical_numericUpDown_ValueChanged(object sender, EventArgs e)
        {

            vertical = (int)vertical_numericUpDown.Value + 60;

        }

        private bool isLeftMouse_Clicked = false;
        private Point mouse_pos;
        int pos = 0;
        int start_pos = 0;


        private void pictureBox2_MouseClick(object sender, MouseEventArgs e)
        {
            pictureBox2.Focus();
            mouse_pos = e.Location;

            mouse_pos.X -= 40;
            if (mouse_pos.X < 0 || mouse_pos.X > 501) return;
            if (mouse_pos.Y < 160 || mouse_pos.Y > 400) return;

            if (e.Button == MouseButtons.Left)
            {
                isLeftMouse_Clicked = !isLeftMouse_Clicked;
                mouse_pos.Y = 400;

                //mouse I͈̔͂ɁA]TB
                for (int j = -6; j < 6; j++)
                {
                    if (mouse_pos.Y >= custumVertcies_spect[mouse_pos.X + j].Y)
                    {
                        mouse_pos.Y = (int)custumVertcies_spect[mouse_pos.X + j].Y;
                        pos = mouse_pos.X + j;
                    }

                }


                ary = vBuffer_mouse.Lock(0, LockFlags.None);

                custumVertcies_mouse[0].X = pos + 40;
                custumVertcies_mouse[0].Z = 0;
                custumVertcies_mouse[0].Rhw = 1.0f;
                custumVertcies_mouse[0].Color = Color.Yellow.ToArgb();
                custumVertcies_mouse[0].Y = 160;

                custumVertcies_mouse[1].X = pos + 40;
                custumVertcies_mouse[1].Z = 0;
                custumVertcies_mouse[1].Rhw = 1.0f;
                custumVertcies_mouse[1].Color = Color.Yellow.ToArgb();
                custumVertcies_mouse[1].Y = 400;

                ary.SetValue(custumVertcies_mouse[0], 0);
                ary.SetValue(custumVertcies_mouse[1], 1);

                vBuffer_mouse.Unlock();

            }
            if (e.Button == MouseButtons.Right)
            {
                start_pos = 0;
                isLeftMouse_Clicked = false;

                correctdB_button.Visible = false;
                correct = false;

                magnifier = numberOfSpectrum / 1024;

                norm = false;
                norm_button.BackColor = Color.Chartreuse;

                if (!alredy_calc)
                    start_pos = calc_start_point(mouse_pos.X);
                else
                {
                    freq_mag *= 2;
                    if (freq_mag >= numberOfSpectrum / 1024)
                        freq_mag = numberOfSpectrum / 1024;//==magnifier
                    start_pos = return_value_current[freq_mag];
                }

            }

        }

        int current_position = 0;
        int return_value = 0;
        int[] return_value_current = new int[65];

        bool isReduce = false;
        bool alredy_calc = false;

        int calc_start_point(int current)
        {
            magnifier = numberOfSpectrum / 1024;
            if (!isReduce)
            {
                //  freq_mag_current *= 2;

                while (freq_mag <= magnifier)
                {
                    freq_mag *= 2;

                    if (freq_mag > 1) reduce_button.Visible = true;

                    if (freq_mag > magnifier)
                    {
                        freq_mag = magnifier;
                        return return_value;
                    }

                    if (freq_mag == 2)
                    {
                        return_value = magnifier / freq_mag * (2 * current - 256);
                        current_position = 2 * current;
                    }
                    else
                    {
                        if (freq_mag <= magnifier)
                        {

                            return_value = magnifier / freq_mag * (2 * current_position - 256);

                            current_position *= 2;

                        }

                    }

                    if (return_value < 0)
                        return_value = 0;

                    // isReduce = false;
                    return_value_current[freq_mag] = return_value;
                    alredy_calc = true;
                }
                current_position = 0;

            }
            else
            {
                if (freq_mag >= 2)
                    freq_mag /= 2;
                if (freq_mag == 1)
                {
                    reduce_button.Visible = false;
                    alredy_calc = false;
                    isReduce = false;

                    correct = false;
                    correctdB_button.Visible = true;

                }
            }
            current_position = 0;
            return return_value_current[freq_mag];

        }

        private void reduce_button_Click(object sender, EventArgs e)
        {

            isReduce = true;
            start_pos = calc_start_point(current_position);

        }



        int delta = 0;

        protected override void OnMouseWheel(MouseEventArgs e)
        {
            base.OnMouseWheel(e);
            // e.Delta = (int)(512 / 12);
            if (freq_mag == 1) return;

            delta += (int)(e.Delta / 40);

        }


        private void fft_comboBox_TextChanged(object sender, EventArgs e)
        {
            if (alredyRead)
            {

                appli_state_save();
                Process my_current = Process.GetCurrentProcess();

                Application.Restart();
                my_current.Kill();

            }

            label1.Focus();

        }

        private void appli_state_save()
        {
            StreamWriter sw = new StreamWriter(@"analysis.ini", false);

            sw.WriteLine("[ FFT number of sampling ]");
            sw.WriteLine(fft_comboBox.Text.ToString());

            sw.WriteLine("[ FFT sampling frequency ]");
            sw.WriteLine(sampling_comboBox.Text.ToString());

            sw.WriteLine("[ adjust dB position ]");
            sw.WriteLine(adjust_UpDown.Value.ToString());
            sw.WriteLine("[ oscilloscope magnify ]");
            sw.WriteLine(mag.ToString());
            sw.WriteLine("[ amplitude volume ]");
            sw.WriteLine(vertical_numericUpDown.Value.ToString());

            sw.Dispose();

            sw.Close();

        }
        private void appli_state_read()
        {
            sr = new StreamReader(@"analysis.ini");
            sr.ReadLine();
            numberOfSpectrum = int.Parse(sr.ReadLine());
            fft_comboBox.Text = numberOfSpectrum.ToString();
            
            sr.ReadLine();
            my_waveformat.SamplesPerSecond = int.Parse(sr.ReadLine());
            sampling_comboBox.Text = my_waveformat.SamplesPerSecond.ToString();
           // sampling_comboBox.Text = (my_waveformat.SamplesPerSecond);

            sr.ReadLine();
            adjust_UpDown.Value = decimal.Parse(sr.ReadLine());

            sr.ReadLine();
            mag = Int32.Parse(sr.ReadLine());
            switch (mag)
            {
                case 1: radioButton1.Select(); break;
                case 2: radioButton2.Select(); break;
                case 4: radioButton3.Select(); break;
                case 6: radioButton4.Select(); break;
                case 8: radioButton5.Select(); break;
                case 10: radioButton6.Select(); break;
            }


            sr.ReadLine();
            vertical_numericUpDown.Value = decimal.Parse(sr.ReadLine());
            vertical = (int)vertical_numericUpDown.Value + 60;

            sr.ReadLine();
            sr.Dispose();
            sr.Close();

        }



        private void MainForm_Activated(object sender, EventArgs e)
        {
            try
            {
                appli_state_read();
            }
            catch
            {

            }


            vertical_numericUpDown.Visible = true;
            Ynormalize_factor = new double[512];

            result = new double[numberOfSpectrum];
            spectrum_result = new double[numberOfSpectrum / 2];

            //my_waveformat.SamplesPerSecondĒ`̂AȉKv
            my_waveformat.BlockAlign = (short)((my_waveformat.Channels) * (my_waveformat.BitsPerSample / 8));
            my_waveformat.AverageBytesPerSecond = my_waveformat.BlockAlign * my_waveformat.SamplesPerSecond;
            inv_Sampling_time = (double)my_waveformat.SamplesPerSecond / numberOfSpectrum;

            CreateCaptureBuffer();

            //Direct3D
            vBuffer = new VertexBuffer(typeof(CustomVertex.TransformedColored), 512, device,
                Usage.None, CustomVertex.TransformedColored.Format, Pool.Managed);

            vBuffer2 = new VertexBuffer(typeof(CustomVertex.TransformedColored), 40 * 46 + 4, device,
                Usage.None, CustomVertex.TransformedColored.Format, Pool.Managed);

            vBuffer3 = new VertexBuffer(typeof(CustomVertex.TransformedColored), 40 * 46, device,
                Usage.None, CustomVertex.TransformedColored.Format, Pool.Managed);

            vBuffer4 = new VertexBuffer(typeof(CustomVertex.TransformedColored), 512, device,
                Usage.None, CustomVertex.TransformedColored.Format, Pool.Managed);

            vBuffer_peak = new VertexBuffer(typeof(CustomVertex.TransformedColored), 512, device,
                Usage.None, CustomVertex.TransformedColored.Format, Pool.Managed);
            vBuffer_mouse = new VertexBuffer(typeof(CustomVertex.TransformedColored), 10, device,
                Usage.None, CustomVertex.TransformedColored.Format, Pool.Managed);


            captureBuffer.Start(true);  //set  capture buffer to Looping
            prepare_draw_oscillo_wave();
            prepare_draw_spect();

            alredyRead = true;
            recButton.Text = "OFF";
            recButton.BackColor = Color.Tomato;
            inv_Sampling_time = (double)my_waveformat.SamplesPerSecond / numberOfSpectrum;


            my_FFT = new CFFT(my_waveformat.SamplesPerSecond, numberOfSpectrum);

            //FPS
            before = Environment.TickCount;


        }

        private void reset_button_Click(object sender, EventArgs e)
        {
            appli_state_save();
            Process my_current = Process.GetCurrentProcess();

            Application.Restart();
            my_current.Kill();

        }

        private void WindowFunc_comboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            selected = WindowFunc_comboBox.SelectedIndex;
            window_func_groupBox.Focus();

        }

        private void toPeak_button_Click(object sender, EventArgs e)
        {
            toPeak = !toPeak;

            if (toPeak)
            {
                peak_button.Visible = false;
                isPeakhold = false;
                norm_button.Visible = false;
                norm_button.BackColor = Color.Chartreuse;
                norm = false;

                peak_button.BackColor = Color.Chartreuse;
                toPeak_button.BackColor = Color.Red;


            }

            else
            {
                toPeak_button.BackColor = Color.Chartreuse;
                peak_button.Visible = true;
                norm_button.Visible = true;

            }

        }



        bool hide_origin = false;

        private void origin_button_Click(object sender, EventArgs e)
        {
            hide_origin = !hide_origin;
            if (hide_origin)
                origin_button.BackColor = Color.Tomato;
            else
                origin_button.BackColor = Color.Chartreuse;

        }

        private void full_span_button_Click(object sender, EventArgs e)
        {
            start_pos = 0;
            freq_mag = 1;
            current_position = 0;
            mouse_pos.X = 0;
            delta = 0;

            norm_button.BackColor = Color.Chartreuse;
            norm_button.Visible = true;
            peak_button.BackColor = Color.Chartreuse;
            isPeakhold = false;
            reduce_button.Visible = false;
            alredy_calc = false;
            freq_mag = 1;

            correctdB_button.Visible = true;
        }

        private void pictureBox2_MouseEnter(object sender, EventArgs e)
        {
            //pictureBox2.Focus();
        }

        private void correctdB_button_Click(object sender, EventArgs e)
        {
            correct = !correct;
            if (correct)
            {
                toPeak_button.Visible = false;
                toPeak = false;

                correctdB_button.BackColor = Color.Tomato;
            }
            else
            {
                toPeak_button.Visible = true;

                correctdB_button.BackColor = Color.MistyRose;
            }
        }

        bool show_input = false;

        private void show_wave_button_Click(object sender, EventArgs e)
        {
            show_input = !show_input;
            if (show_input)
            {
                show_wave_button.BackColor = Color.MistyRose;
                show_wave_button.Text = "input wave";
            }
            else
            {
                show_wave_button.BackColor = Color.Aqua;
                show_wave_button.Text = "output wave";
            }
        }

        private void sampling_comboBox_SelectedIndexChanged(object sender, EventArgs e)
        {


        }

        private void sampling_comboBox_TextChanged(object sender, EventArgs e)
        {
            if (alredyRead)
            {
                appli_state_save();
                Process my_current = Process.GetCurrentProcess();

                Application.Restart();
                my_current.Kill();
            }
        }




 


    }
}